﻿Imports Microsoft.AspNet.Identity
Imports Microsoft.AspNet.Identity.EntityFramework
Imports Microsoft.AspNet.Identity.Owin
Imports Microsoft.Owin
Imports Microsoft.Owin.Security.Cookies
Imports Microsoft.Owin.Security.DataProtection
Imports Owin
Imports FrontClass.Models

Namespace FrontClass
	Partial Public Class Startup
		' For more information on configuring authentication, please visit http://go.microsoft.com/fwlink/?LinkId=301864
		Public Sub ConfigureAuth(ByVal app As IAppBuilder)
			' Configure the db context and user manager to use a single instance per request
			app.CreatePerOwinContext(AddressOf ApplicationDbContext.Create)
			app.CreatePerOwinContext(Of ApplicationUserManager)(AddressOf ApplicationUserManager.Create)

			' Enable the application to use a cookie to store information for the signed in user
			' and to use a cookie to temporarily store information about a user logging in with a third party login provider
			' Configure the sign in cookie
			app.UseCookieAuthentication(New CookieAuthenticationOptions With {.AuthenticationType = DefaultAuthenticationTypes.ApplicationCookie, .LoginPath = New PathString("/Account/Login"), .Provider = New CookieAuthenticationProvider With {.OnValidateIdentity = SecurityStampValidator.OnValidateIdentity(Of ApplicationUserManager, ApplicationUser)(validateInterval:= TimeSpan.FromMinutes(30), regenerateIdentity:= Function(manager, user) user.GenerateUserIdentityAsync(manager))}})

			app.UseExternalSignInCookie(DefaultAuthenticationTypes.ExternalCookie)

			' Uncomment the following lines to enable logging in with third party login providers
			'app.UseMicrosoftAccountAuthentication(
			'    clientId: "",
			'    clientSecret: "");

			'app.UseTwitterAuthentication(
			'   consumerKey: "",
			'   consumerSecret: "");

			'app.UseFacebookAuthentication(
			'   appId: "",
			'   appSecret: "");

			'app.UseGoogleAuthentication();
		End Sub
	End Class
End Namespace