﻿Imports System.Globalization
Imports System.Security.Claims
Imports System.Web.Mvc
Imports FrontClass.DAL
Imports FrontClass.Models
Imports Microsoft.AspNet.Identity
Imports Microsoft.AspNet.Identity.EntityFramework

Namespace FrontClass.Controllers
	<Authorize>
	Public Class EnrolmentController
		Inherits Controller
		Private db As New FrontClassContext()

		' GET: Enrolment
		Public Function Index() As ActionResult
			Dim enrolment = BuildCourseEnrolmentViewModel()

			Return View(enrolment)
		End Function

		Private Function BuildCourseEnrolmentViewModel() As CourseEnrolmentViewModel
Dim context = New ApplicationDbContext()
Dim userStore = New UserStore(Of ApplicationUser)(context)
Dim userManager = New UserManager(Of ApplicationUser)(userStore)

Dim userId = User.Identity.GetUserId()
Dim claims = userManager.GetClaims(userId).Where(Function(c) c.Type = MvcApplication.CourseRegistrationClaimUrn).ToList()

			Dim courses = db.Courses

			Dim enrolment = New CourseEnrolmentViewModel()

			For Each course In courses
				Dim enrolled = claims.Any(Function(c) c.Value = course.CourseId.ToString(CultureInfo.InvariantCulture))
				enrolment.Courses.Add(course, enrolled)
			Next course
			Return enrolment
		End Function


		<HttpPost>
		Public Function Index(ByVal enrol As EnrolInCourseViewModel) As ActionResult
			' verify entry code for course
			If Not db.Courses.Any(Function(c) c.CourseId = enrol.CourseId AndAlso c.EntryCode = enrol.EntryCode) Then
				TempData("CourseRegistrationError") = "Could not find a course for the entry code provided."
				Return RedirectToAction("Index")
			End If
			Dim context = New ApplicationDbContext()
			Dim userStore = New UserStore(Of ApplicationUser)(context)
			Dim userManager = New UserManager(Of ApplicationUser)(userStore)

			Dim userId = User.Identity.GetUserId()
			Dim courseClaim = New Claim(MvcApplication.CourseRegistrationClaimUrn, enrol.CourseId.ToString(CultureInfo.InvariantCulture))
			userManager.AddClaim(userId, courseClaim)

			Return RedirectToAction("Index")
		End Function

	End Class
End Namespace