﻿Imports Microsoft.AspNet.SignalR

Namespace FrontClass.Hubs
	Public Class ClassroomHub
		Inherits Hub
		<Authorize(Roles := MvcApplication.AdministratorRoleName)>
		Public Sub MakeStepAvailable(ByVal stepId As Integer)
			MvcApplication.Classroom.MakeStepAvailable(stepId)

			Clients.All.notifyStepAvailable(stepId)
		End Sub

		<Authorize(Roles := MvcApplication.AdministratorRoleName)>
		Public Sub StartModule(ByVal moduleId As Integer)
			MvcApplication.Classroom.StartModule(moduleId)
		End Sub

		<Authorize>
		Public Sub GetAvailableSteps()
			Dim steps = MvcApplication.Classroom.AvailableSteps.Select(Function(s) New With {Key s.StepId, Key s.Title})

			Clients.Caller.notifyAvailableSteps(steps)
		End Sub
	End Class
End Namespace