Imports System.Data.Entity.Migrations

Namespace FrontClass.Migrations

	Partial Public Class InitialModel
		Inherits DbMigration
		Public Overrides Sub Up()
			CreateTable("dbo.Course", Function(c) New With {Key .CourseId = c.Int(nullable:= False, identity:= True), Key .Title = c.String(nullable:= False), Key .Description = c.String(), Key .EntryCode = c.String()}).PrimaryKey(Function(t) t.CourseId)

			CreateTable("dbo.Module", Function(c) New With {Key .ModuleId = c.Int(nullable:= False, identity:= True), Key .Title = c.String(nullable:= False), Key .Description = c.String(), Key .CourseId = c.Int(nullable:= False)}).PrimaryKey(Function(t) t.ModuleId).ForeignKey("dbo.Course", Function(t) t.CourseId, cascadeDelete:= True).Index(Function(t) t.CourseId)

			CreateTable("dbo.Step", Function(c) New With {Key .StepId = c.Int(nullable:= False, identity:= True), Key .Title = c.String(nullable:= False), Key .Content = c.String(), Key .ModuleId = c.Int(nullable:= False)}).PrimaryKey(Function(t) t.StepId).ForeignKey("dbo.Module", Function(t) t.ModuleId, cascadeDelete:= True).Index(Function(t) t.ModuleId)

		End Sub

		Public Overrides Sub Down()
			DropForeignKey("dbo.Step", "ModuleId", "dbo.Module")
			DropForeignKey("dbo.Module", "CourseId", "dbo.Course")
			DropIndex("dbo.Step", { "ModuleId" })
			DropIndex("dbo.Module", { "CourseId" })
			DropTable("dbo.Step")
			DropTable("dbo.Module")
			DropTable("dbo.Course")
		End Sub
	End Class
End Namespace
