Imports System.Data.Entity.Migrations
Imports System.Data.Entity
Imports FrontClass.DAL
Imports FrontClass.Models
Imports Microsoft.AspNet.Identity
Imports Microsoft.AspNet.Identity.EntityFramework
Imports System
Imports System.Linq.Enumerable

Namespace FrontClass.Migrations
    Friend NotInheritable Class Configuration
        Inherits DbMigrationsConfiguration(Of FrontClass.DAL.FrontClassContext)
        Public Sub New()
            AutomaticMigrationsEnabled = False
        End Sub

        Protected Overrides Sub Seed(ByVal context As FrontClass.DAL.FrontClassContext)
            Dim courseTitle = "Learning Math"
            'Dim predicate As System.Func(Of FrontClass.Models.Course, Boolean) = ()
            If Not context.Courses.Any(Function(c As FrontClass.Models.Course) c.Title = courseTitle) Then
                Dim mathCourse = New Course With {.Title = courseTitle, .EntryCode = "welcome"}
                context.Courses.AddOrUpdate(Function(course) course.Title, mathCourse)
                Dim firstModule = New [Module] With {.Title = "Math Basics", .Course = mathCourse}

                context.Modules.AddOrUpdate(Function(modulea As [Module]) modulea.Title,
                                            firstModule, New [Module] With {.Title = "Fun with Hexidecimal", .Course = mathCourse}, New [Module] With {.Title = "Statistics and You", .Course = mathCourse}, New [Module] With {.Title = "Calculus for Fun and Profit", .Course = mathCourse})

                context.Steps.AddOrUpdate(Function(stepa As [Step]) stepa.Title,
                                                              New [Step] With {.Title = "Addition", .Module = firstModule, .Content = "<h1>Welcome to the course!</h1><p>So, you've decided to learn math. Good on ya! You'll find that it's as easy as 1-2-3.</p><p>This course assumes that you have number recognition down pat, and understand the mechanics of counting.</p><p>Let's start with one of the most basic parts of math, addition.</p><h2>Addition</h2><p>Also known as 'adding', addition refers to computing the sum of two or more numbers.</p>"}, New [Step] With {.Title = "Subtraction", .Module = firstModule, .Content = "<h1>This is step 2 content.</h1><p>Replace this content with your own.</p>"}, New [Step] With {.Title = "Multiplication", .Module = firstModule, .Content = "<h1>This is step 3 content.</h1><p>Replace this content with your own.</p>"}, New [Step] With {.Title = "Division", .Module = firstModule, .Content = "<h1>This is step 4 content.</h1><p>Replace this content with your own.</p>"}, New [Step] With {.Title = "Order of Operations", .Module = firstModule, .Content = "<h1>This is step 5 content.</h1><p>Replace this content with your own.</p>"})
                context.SaveChanges()
            End If
        End Sub
    End Class
End Namespace
