Imports System.Data.Entity.Migrations

Namespace FrontClass.Models.AccountMigrations

	Partial Public Class InitialModel
		Inherits DbMigration
		Public Overrides Sub Up()
			CreateTable("dbo.AspNetRoles", Function(c) New With {Key .Id = c.String(nullable:= False, maxLength:= 128), Key .Name = c.String(nullable:= False, maxLength:= 256)}).PrimaryKey(Function(t) t.Id).Index(Function(t) t.Name, unique:= True, name:= "RoleNameIndex")

			CreateTable("dbo.AspNetUserRoles", Function(c) New With {Key .UserId = c.String(nullable:= False, maxLength:= 128), Key .RoleId = c.String(nullable:= False, maxLength:= 128)}).PrimaryKey(Function(t) New With {Key t.UserId, Key t.RoleId}).ForeignKey("dbo.AspNetRoles", Function(t) t.RoleId, cascadeDelete:= True).ForeignKey("dbo.AspNetUsers", Function(t) t.UserId, cascadeDelete:= True).Index(Function(t) t.UserId).Index(Function(t) t.RoleId)

			CreateTable("dbo.AspNetUsers", Function(c) New With {Key .Id = c.String(nullable:= False, maxLength:= 128), Key .Email = c.String(maxLength:= 256), Key .EmailConfirmed = c.Boolean(nullable:= False), Key .PasswordHash = c.String(), Key .SecurityStamp = c.String(), Key .PhoneNumber = c.String(), Key .PhoneNumberConfirmed = c.Boolean(nullable:= False), Key .TwoFactorEnabled = c.Boolean(nullable:= False), Key .LockoutEndDateUtc = c.DateTime(), Key .LockoutEnabled = c.Boolean(nullable:= False), Key .AccessFailedCount = c.Int(nullable:= False), Key .UserName = c.String(nullable:= False, maxLength:= 256)}).PrimaryKey(Function(t) t.Id).Index(Function(t) t.UserName, unique:= True, name:= "UserNameIndex")

			CreateTable("dbo.AspNetUserClaims", Function(c) New With {Key .Id = c.Int(nullable:= False, identity:= True), Key .UserId = c.String(nullable:= False, maxLength:= 128), Key .ClaimType = c.String(), Key .ClaimValue = c.String()}).PrimaryKey(Function(t) t.Id).ForeignKey("dbo.AspNetUsers", Function(t) t.UserId, cascadeDelete:= True).Index(Function(t) t.UserId)

			CreateTable("dbo.AspNetUserLogins", Function(c) New With {Key .LoginProvider = c.String(nullable:= False, maxLength:= 128), Key .ProviderKey = c.String(nullable:= False, maxLength:= 128), Key .UserId = c.String(nullable:= False, maxLength:= 128)}).PrimaryKey(Function(t) New With {Key t.LoginProvider, Key t.ProviderKey, Key t.UserId}).ForeignKey("dbo.AspNetUsers", Function(t) t.UserId, cascadeDelete:= True).Index(Function(t) t.UserId)

		End Sub

		Public Overrides Sub Down()
			DropForeignKey("dbo.AspNetUserRoles", "UserId", "dbo.AspNetUsers")
			DropForeignKey("dbo.AspNetUserLogins", "UserId", "dbo.AspNetUsers")
			DropForeignKey("dbo.AspNetUserClaims", "UserId", "dbo.AspNetUsers")
			DropForeignKey("dbo.AspNetUserRoles", "RoleId", "dbo.AspNetRoles")
			DropIndex("dbo.AspNetUserLogins", { "UserId" })
			DropIndex("dbo.AspNetUserClaims", { "UserId" })
			DropIndex("dbo.AspNetUsers", "UserNameIndex")
			DropIndex("dbo.AspNetUserRoles", { "RoleId" })
			DropIndex("dbo.AspNetUserRoles", { "UserId" })
			DropIndex("dbo.AspNetRoles", "RoleNameIndex")
			DropTable("dbo.AspNetUserLogins")
			DropTable("dbo.AspNetUserClaims")
			DropTable("dbo.AspNetUsers")
			DropTable("dbo.AspNetUserRoles")
			DropTable("dbo.AspNetRoles")
		End Sub
	End Class
End Namespace
