Imports System.Data.Entity.Migrations
Imports System.Data.Entity

Imports Microsoft.AspNet.Identity
Imports Microsoft.AspNet.Identity.EntityFramework

Namespace FrontClass.Models.AccountMigrations

	Friend NotInheritable Class Configuration
		Inherits DbMigrationsConfiguration(Of FrontClass.Models.ApplicationDbContext)
		Public Sub New()
			AutomaticMigrationsEnabled = False
			MigrationsDirectory = "Models\AccountMigrations"
		End Sub

		Protected Overrides Sub Seed(ByVal context As FrontClass.Models.ApplicationDbContext)

			If Not context.Roles.Any(Function(r) r.Name = FrontClass.MvcApplication.AdministratorRoleName) Then
				Dim roleStore = New RoleStore(Of IdentityRole)(context)
				Dim roleManager = New RoleManager(Of IdentityRole)(roleStore)
				Dim identityRole = New IdentityRole With {.Name = FrontClass.MvcApplication.AdministratorRoleName}

				roleManager.Create(identityRole)
			End If

			Dim instructorName = "instructor@contonso.com"
			If Not context.Users.Any(Function(u) u.UserName = instructorName) Then
				Dim userStore = New UserStore(Of ApplicationUser)(context)
				Dim userManager = New UserManager(Of ApplicationUser)(userStore)
				Dim applicationUser = New ApplicationUser With {.UserName = instructorName}

				userManager.Create(applicationUser, "init_2014")
				userManager.AddToRole(applicationUser.Id, FrontClass.MvcApplication.AdministratorRoleName)
			End If
		End Sub
	End Class
End Namespace
