﻿Imports System.Data.Entity
Imports FrontClass.DAL

Namespace FrontClass.Models
	Public Class Classroom
        Private _availableSteps As List(Of FrontClass.Models.Step)
		Private _currentStep As [Step]

		Private privateCurrentModule As [Module]
		Public Property CurrentModule() As [Module]
			Get
				Return privateCurrentModule
			End Get
			Private Set(ByVal value As [Module])
				privateCurrentModule = value
			End Set
		End Property
		Private privateStudents As List(Of ApplicationUser)
		Public Property Students() As List(Of ApplicationUser)
			Get
				Return privateStudents
			End Get
			Private Set(ByVal value As List(Of ApplicationUser))
				privateStudents = value
			End Set
		End Property
		Private privateInstructors As List(Of ApplicationUser)
		Public Property Instructors() As List(Of ApplicationUser)
			Get
				Return privateInstructors
			End Get
			Private Set(ByVal value As List(Of ApplicationUser))
				privateInstructors = value
			End Set
		End Property

		Private db As New FrontClassContext()

		Public Sub New()
            _availableSteps = New List(Of FrontClass.Models.Step)()
			Students = New List(Of ApplicationUser)()
			Instructors = New List(Of ApplicationUser)()
		End Sub

        Public ReadOnly Property AvailableSteps() As IEnumerable(Of FrontClass.Models.Step)
            Get
                Return _availableSteps.OrderBy(Function(s) s.StepId).ToList()
            End Get
        End Property

		Public ReadOnly Property CurrentStep() As [Step]
			Get
				Return _currentStep
			End Get
		End Property

		Public Sub StartModule(ByVal moduleId As Integer)
            _availableSteps = New List(Of FrontClass.Models.Step)()

			Dim [module] = db.Modules.Include(Function(m) m.Course).First(Function(m) m.ModuleId = moduleId)

			CurrentModule = [module]
		End Sub

		Public Sub MakeStepAvailable(ByVal stepId As Integer)
			Dim [step] = db.Steps.Find(stepId)

			If Not _availableSteps.Contains([step]) Then
				_availableSteps.Add([step])
			End If
			_currentStep = [step]
		End Sub



	End Class
End Namespace